/*----------------------------------------------------------------------
  File    : data.cpp
  Contents: data set management
  Author  : Bart Goethals
  Update  : 13/5/2005
  Adapted for attribute-values and missing data:
  Author  : Michael Mampaey
  Date    : 10/02/2006
  ----------------------------------------------------------------------*/

#include <vector>
#include "data.h"
using namespace std;


Transaction::Transaction(const Transaction &tr)
{
    length = tr.length;
    t = new string*[length];
    for(int i=0; i<length; ++i) t[i] = new string(*(tr.t[i]));
}

Transaction::~Transaction()
{
    for(int i=0;i<length;++i)
        delete t[i];
    delete [] t;
}

Data::Data(char *filename)
{
    fn = filename;
    in = fopen(fn,"rt");
}

Data::~Data()
{
    if(in) fclose(in);
}


Transaction* Data::getNext()
{
    vector<string*> list;
    char c;
    string *val;
    
    // read list of attr-value pairs
    // ' '=32  '('=40 ')'=41 ','=44 '?'=63 
    if(feof(in)) return 0;
    do {
        val = new string;
        while ((c=getc(in))<=' ' && !feof(in));
        
        while (c!=',' && c!='\n' && !feof(in)) {
            val->push_back(c);
            c = getc(in);
        }
        list.push_back(val);
        
    } while (c!='\n' && !feof(in));
    
    if(feof(in)) return 0;
    // Note, also last transaction must end with newline, 
    // else, it will be ignored
    
    // put attr-val pairs in Transaction structure
    Transaction *t = new Transaction(list.size());
    for(unsigned i=0; i<list.size(); ++i)
        t->t[i] = list[i];
    
    return t;
}