/*----------------------------------------------------------------------
* File    : testxminer.cpp
* Descr.  : XMiner algorithm for finding frequent representative 
*           itemsets in incomplete datasets
* Author  : Michael Mampaey
* --------------------------------------------------------------------*/

#include <iostream>
#include "item.h"
#include "data.h"
#include "xminer.h"
using namespace std;


int main(int argc, char *argv[])
{
    if(argc < 4) {
        cerr << "usage: " << argv[0] << " datafile minrep minsup [output] [--verbose]" << endl;
        return 1;
    }
    else {
    XMiner xminer;
        xminer.setData(argv[1]);
        xminer.setMinrep(atof(argv[2]));
        xminer.setMinsup(atof(argv[3]));
        
        string verb = "--verbose";
        if (argc==5) {
    	    if (verb.compare(argv[4])==0)
    	        xminer.setVerbose(true);
        	else
                xminer.setOutput(argv[4]);
        }
        else if (argc==6 && verb.compare(argv[5])==0) {
            xminer.setOutput(argv[4]);
            xminer.setVerbose(true);
        }
        
        return ( xminer.mine() < 0 );
        
    }
}
