/*----------------------------------------------------------------------
* File    : xminer.h
* Descr.  : XMiner algorithm for finding frequent representative
*           itemsets in incomplete datasets
* Author  : Michael Mampaey
* Date    : 01/03/2006
* --------------------------------------------------------------------*/
 
#include <set>
#include <string>
using namespace std;


class XMiner
{
public:
    
    XMiner();
    ~XMiner();
    
    void setData(char *file) { data = new Data(file); }
    void setMinrep(double mr) { minrep = mr; }
    void setMinsup(double ms) { minsup = ms; }
    void setOutput(char *of) { out = fopen(of, "wt"); }
    void setVerbose(bool v) { verbose = v; }
    
    double mine();
    
protected:
    
    double grow(multiset<Attribute> *items, pair<int,string*> *itemset, int depth, pair<int,string*> *comb, int cl);
    void print(pair<int,string*> *itemset, int il, pair<int,string*> *comb, int cl, int support, int denom) const;
    
    Data *data;
    FILE *out;
    
    int tcount;
    double minrep;
    double minsup;
    double minrepcount;
    
    int candidates;
    int extensibleCandidates;
    
    bool verbose;
};
